module MonadWithList where

newtype WithList m a = WithList { unwithlist :: m [a] }

instance Monad m => Monad (WithList m) where
    return = WithList . return . return
    {-# INLINE return #-}
    (WithList a) >>= f = WithList (a >>= mapM (unwithlist . f) >>= return . concat)

